import { __decorate, __metadata } from "tslib";
import { bindable, customElement, inject } from 'aurelia';
import { booleanAttr, handlesAttr, number } from '../../interceptors';
import { GridStack } from '../grid-stack/grid-stack';
import template from './grid-stack-item.html';
let GridStackItem = class GridStackItem {
    constructor(root, gridstack) {
        this.root = root;
        this.gridstack = gridstack;
        this.suppressGridUpdate = false;
    }
    xChanged() {
        var _a;
        if (this.x !== undefined) {
            this.root.setAttribute('gs-x', this.x.toString());
        }
        else {
            this.root.removeAttribute('gs-x');
        }
        if (!this.suppressGridUpdate) {
            (_a = this.gridstack.grid) === null || _a === void 0 ? void 0 : _a.update(this.root, { x: this.x });
        }
    }
    yChanged() {
        var _a;
        if (this.y !== undefined) {
            this.root.setAttribute('gs-y', this.y.toString());
        }
        else {
            this.root.removeAttribute('gs-y');
        }
        if (!this.suppressGridUpdate) {
            (_a = this.gridstack.grid) === null || _a === void 0 ? void 0 : _a.update(this.root, { y: this.y });
        }
    }
    wChanged() {
        var _a;
        if (this.w !== undefined) {
            this.root.setAttribute('gs-w', this.w.toString());
        }
        else {
            this.root.removeAttribute('gs-w');
        }
        if (!this.suppressGridUpdate) {
            (_a = this.gridstack.grid) === null || _a === void 0 ? void 0 : _a.update(this.root, { w: this.w });
        }
    }
    hChanged() {
        var _a;
        if (this.h !== undefined) {
            this.root.setAttribute('gs-h', this.h.toString());
        }
        else {
            this.root.removeAttribute('gs-h');
        }
        if (!this.suppressGridUpdate) {
            (_a = this.gridstack.grid) === null || _a === void 0 ? void 0 : _a.update(this.root, { h: this.h });
        }
    }
    minWChanged() {
        if (this.minW !== undefined) {
            this.root.setAttribute('gs-min-w', this.minW.toString());
        }
        else {
            this.root.removeAttribute('gs-min-w');
        }
    }
    minHChanged() {
        if (this.minH !== undefined) {
            this.root.setAttribute('gs-min-h', this.minH.toString());
        }
        else {
            this.root.removeAttribute('gs-min-h');
        }
    }
    maxWChanged() {
        if (this.maxW !== undefined) {
            this.root.setAttribute('gs-max-w', this.maxW.toString());
        }
        else {
            this.root.removeAttribute('gs-max-w');
        }
    }
    maxHChanged() {
        if (this.maxH !== undefined) {
            this.root.setAttribute('gs-max-h', this.maxH.toString());
        }
        else {
            this.root.removeAttribute('gs-max-h');
        }
    }
    idChanged() {
        if (this.id !== undefined) {
            this.root.setAttribute('gs-id', this.id.toString());
        }
        else {
            this.root.removeAttribute('gs-id');
        }
    }
    noMoveChanged() {
        if (this.noMove) {
            this.root.setAttribute('gs-no-move', 'true');
        }
        else {
            this.root.removeAttribute('gs-no-move');
        }
    }
    noResizeChanged() {
        if (this.noResize) {
            this.root.setAttribute('gs-no-resize', 'true');
        }
        else {
            this.root.removeAttribute('gs-no-resize');
        }
    }
    lockedChanged() {
        if (this.locked) {
            this.root.setAttribute('gs-locked', 'true');
        }
        else {
            this.root.removeAttribute('gs-locked');
        }
    }
    autoPositionChanged() {
        if (this.autoPosition) {
            this.root.setAttribute('gs-auto-position', 'true');
        }
        else {
            this.root.removeAttribute('gs-auto-position');
        }
    }
    resizeHandlesChanged() {
        if (this.resizeHandles !== undefined) {
            this.root.setAttribute('gs-resize-handles', this.resizeHandles.toString());
        }
        else {
            this.root.removeAttribute('gs-resize-handles');
        }
    }
    attached() {
        if (this.x !== undefined) {
            this.xChanged();
        }
        if (this.y !== undefined) {
            this.yChanged();
        }
        if (this.w !== undefined) {
            this.wChanged();
        }
        if (this.h !== undefined) {
            this.hChanged();
        }
        if (this.minW !== undefined) {
            this.minWChanged();
        }
        if (this.minH !== undefined) {
            this.minHChanged();
        }
        if (this.maxW !== undefined) {
            this.maxWChanged();
        }
        if (this.maxH !== undefined) {
            this.maxHChanged();
        }
        if (this.noMove !== undefined) {
            this.noMoveChanged();
        }
        if (this.noResize !== undefined) {
            this.noResizeChanged();
        }
        if (this.locked !== undefined) {
            this.lockedChanged();
        }
        if (this.id !== undefined) {
            this.idChanged();
        }
        if (this.autoPosition !== undefined) {
            this.autoPositionChanged();
        }
        if (this.resizeHandles !== undefined) {
            this.resizeHandlesChanged();
        }
    }
    beginSuppressUpdate() {
        this.suppressGridUpdate = true;
    }
    endSuppressUpdate() {
        this.suppressGridUpdate = false;
    }
};
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "x", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "y", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "w", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "h", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "minW", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "minH", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "maxW", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "maxH", void 0);
__decorate([
    bindable({ set: number, mode: 6 /* BindingMode.twoWay */ }),
    __metadata("design:type", Number)
], GridStackItem.prototype, "id", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStackItem.prototype, "noMove", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStackItem.prototype, "noResize", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStackItem.prototype, "locked", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStackItem.prototype, "autoPosition", void 0);
__decorate([
    bindable({ set: handlesAttr }),
    __metadata("design:type", Array)
], GridStackItem.prototype, "resizeHandles", void 0);
GridStackItem = __decorate([
    inject(Element, GridStack),
    customElement({ name: 'grid-stack-item', template }),
    __metadata("design:paramtypes", [Object, GridStack])
], GridStackItem);
export { GridStackItem };
//# sourceMappingURL=grid-stack-item.js.map