import { __decorate, __metadata } from "tslib";
import { bindable, children, customElement, CustomElement } from 'aurelia';
import { booleanAttr, number } from '../../interceptors';
import * as gs from 'gridstack';
import template from './grid-stack.html';
let GridStack = class GridStack {
    constructor(root) {
        this.root = root;
    }
    minRowChanged() {
        this.root.setAttribute('gs-min-row', this.minRow.toString());
    }
    floatChanged() {
        var _a;
        (_a = this.grid) === null || _a === void 0 ? void 0 : _a.float(this.float);
    }
    staticChanged() {
        var _a;
        (_a = this.grid) === null || _a === void 0 ? void 0 : _a.setStatic(this.static);
    }
    itemsChanged() {
        if (!this.grid || !this.items) {
            return;
        }
        const removed = this.grid.engine.nodes.filter(x => { var _a; return !((_a = x.el) === null || _a === void 0 ? void 0 : _a.classList.contains('grid-stack-placeholder')) && !this.items.find(y => y.root === x.el); });
        removed.forEach(x => this.grid.engine.removeNode(x, false, false));
        const newItems = this.items.map(x => x.root).filter(x => !x.gridstackNode);
        newItems.forEach(x => {
            this.grid.addWidget(x);
            if (x.gridstackNode) {
                this.updateNodeVmAttributes(x.gridstackNode);
            }
        });
    }
    attached() {
        var _a;
        const options = (_a = this.options) !== null && _a !== void 0 ? _a : {};
        if (this.float !== undefined) {
            options.float = this.float;
        }
        if (this.static !== undefined) {
            options.staticGrid = this.static;
        }
        this.grid = gs.GridStack.init(options, this.root);
    }
    detached() {
        this.grid.destroy();
        this.grid = undefined;
    }
    handleChange(nodes) {
        if (!(nodes instanceof Array)) {
            return;
        }
        nodes.forEach(x => this.updateNodeVmAttributes(x));
    }
    updateNodeVmAttributes(node) {
        if (node.el) {
            const itemVm = CustomElement.for(node.el).viewModel;
            itemVm.beginSuppressUpdate();
            itemVm.x = node.x;
            itemVm.y = node.y;
            itemVm.w = node.w;
            itemVm.h = node.h;
            itemVm.endSuppressUpdate();
        }
    }
};
__decorate([
    bindable({ set: number }),
    __metadata("design:type", Number)
], GridStack.prototype, "minRow", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStack.prototype, "float", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], GridStack.prototype, "static", void 0);
__decorate([
    bindable,
    __metadata("design:type", Object)
], GridStack.prototype, "options", void 0);
__decorate([
    children({ filter: (el) => { return el.tagName === 'GRID-STACK-ITEM'; } }),
    __metadata("design:type", Array)
], GridStack.prototype, "items", void 0);
GridStack = __decorate([
    customElement({ name: 'grid-stack', template }),
    __metadata("design:paramtypes", [Element])
], GridStack);
export { GridStack };
//# sourceMappingURL=grid-stack.js.map