import { ResizeHandles } from './models';
export function number(a) {
    return Number(a);
}
export function booleanAttr(val) {
    return val || val === '' ? true : false;
}
function onlyUnique(value, index, self) {
    return self.indexOf(value) === index;
}
export function handlesAttr(handles) {
    if (!handles) {
        return [];
    }
    let allEntries;
    if (typeof handles === 'string') {
        allEntries = handles.replace(/\s/g, '').split(',');
    }
    else if (Array.isArray(handles)) {
        allEntries = handles;
    }
    else {
        return [];
    }
    // remove duplicates
    allEntries = allEntries.filter(onlyUnique);
    // add only ResizeHandleType items
    const handlesArray = [];
    allEntries.forEach(child => {
        if (child in ResizeHandles) {
            handlesArray.push(child);
        }
    });
    return handlesArray;
}
//# sourceMappingURL=interceptors.js.map